<template>
    <div class="user-rectangle">
        <b-container>
            <b-row>
                <input 
                    ref="fileInput" 
                    type="file" 
                    @input="pickFile" 
                    style="display: none"
                >
                <b-button 
                    class="edit-image-btn" 
                    size="md" 
                    @click="selectImage" 
                    :style="{ 'background-image': `url(${previewImage})` }" 
                    @mouseover="hover = true" 
                    @mouseleave="hover = false"
                >
                <h4 v-if="hover" class="edit-text"> Edit image </h4>
                </b-button>
            </b-row>
        </b-container>
        <div class="RegisterComponent">
            <b-form @submit="onSubmit">
                <div class="row mx-2 mt-4">
                    <div class="col">
                        <b-form-input
                            id="userName"
                            v-model="user.first_name"
                            type="text"
                            placeholder="Firstname"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col">
                        <b-form-input
                            id="userName"
                            v-model="user.last_name"
                            type="text"
                            placeholder="Lastname"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col">
                        <b-form-input
                            id="address"
                            v-model="street"
                            type="text"
                            placeholder="Adresse"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col-5">
                        <b-form-input
                            id="postcode"
                            v-model="postcode"
                            type="text"
                            placeholder="Postcode"
                            required
                        ></b-form-input>
                    </div>

                    <div class="col-7">
                        <b-form-input
                            id="city"
                            v-model="city"
                            type="text"
                            placeholder="City"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col">
                        <b-form-input
                            id="country"
                            v-model="country"
                            type="text"
                            placeholder="Pays"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col">
                        <b-form-input
                            id="userName"
                            v-model="user.phone_number"
                            type="text"
                            placeholder="Phone Number"
                            required
                        ></b-form-input>
                    </div>
                </div>

                <div class="row mx-2 mt-2">
                    <div class="col">
                        <b-form-input
                            id="userName"
                            v-model="user.email"
                            type="text"
                            placeholder="Email"
                            required
                        ></b-form-input>
                    </div>
                </div>
                    
                <div class="row mx-2 mt-4">
                    <div class="col">
                        <b-button type="submit" @click="onSubmit" variant="secondary">Validate</b-button>
                    </div>
                </div>
            </b-form>            
        </div>
    </div>
</template>

<script>
import Vue from "vue";
import { mapActions } from "vuex";

export default Vue.extend({
    data: () => ({
        user: {
            first_name: "",
            last_name: "",
            address: "",
            email: "",
            phone_number: "",
        },
        street: "",
        postcode: "",
        city: "",
        country: "",
        previewImage: null,
        hover: false,   
    }),

    methods: {
      selectImage () {
          this.$refs.fileInput.click()
      },
      pickFile () {
        let input = this.$refs.fileInput
        let file = input.files
        if (file && file[0]) {
          let reader = new FileReader
          reader.onload = e => {
            this.previewImage = e.target.result
          }
          reader.readAsDataURL(file[0])
          this.$emit('input', file[0])
        }
      },
      ...mapActions(["updateUser"]),
      onSubmit() {
      this.user.address = this.street.concat(";" + this.postcode + ";" + this.city + ";" + this.country);
      delete this.user.password
      this.updateUser(this.user)
    },
  },
  mounted() {
        if (localStorage.user) {
            this.user = JSON.parse(localStorage.user);
            const fullAddress = this.user.address.split(';')
            this.street = fullAddress[0]
            this.postcode = fullAddress[1]
            this.city = fullAddress[2]
            this.country = fullAddress[3]
        }
    }
});

</script>

<style scoped>

.user-rectangle {
    background-color: #FFF1D8;
	width:350px;
	height:550px;
    border-radius: 20px;
    margin-top: 10px;
    margin-left: 15px;
    margin: auto;
}

.edit-image-btn{
    background-color: #A9A9A9;
    border-radius: 100%;
    cursor: pointer;
    width:100px;
	height:100px;
    margin: auto;
    margin-top: 10px;
    background-size: cover;
    background-position: center center;
    
}

.edit-image-btn:hover{
    background-blend-mode: darken;
    border-radius: 100%;
    cursor: pointer;
    width:100px;
	height:100px;
    margin: auto;
    margin-top: 10px;
    background-size: cover;
    background-position: center center;
}

.edit-text{
    color: #FFFFFF;
    font-size: 14px;
    
}

</style>

